# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from ...core.unchecked_base_model import UncheckedBaseModel
from .rendered_message_block import RenderedMessageBlock


class RenderedMessageContent(UncheckedBaseModel):
    html: str = pydantic_v1.Field()
    """
    The html content of the rendered message.
    """

    title: str = pydantic_v1.Field()
    """
    The title of the rendered message.
    """

    body: str = pydantic_v1.Field()
    """
    The body of the rendered message.
    """

    subject: str = pydantic_v1.Field()
    """
    The subject of the rendered message.
    """

    text: str = pydantic_v1.Field()
    """
    The text of the rendered message.
    """

    blocks: typing.List[RenderedMessageBlock] = pydantic_v1.Field()
    """
    The blocks of the rendered message.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
