# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from ...core.unchecked_base_model import UncheckedBaseModel
from .default_preferences import DefaultPreferences


class Tenant(UncheckedBaseModel):
    id: str = pydantic_v1.Field()
    """
    Id of the tenant.
    """

    name: str = pydantic_v1.Field()
    """
    Name of the tenant.
    """

    parent_tenant_id: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Tenant's parent id (if any).
    """

    default_preferences: typing.Optional[DefaultPreferences] = pydantic_v1.Field(default=None)
    """
    Defines the preferences used for the account when the user hasn't specified their own.
    """

    properties: typing.Optional[typing.Dict[str, typing.Any]] = pydantic_v1.Field(default=None)
    """
    Arbitrary properties accessible to a template.
    """

    user_profile: typing.Optional[typing.Dict[str, typing.Any]] = pydantic_v1.Field(default=None)
    """
    A user profile object merged with user profile on send.
    """

    brand_id: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Brand to be used for the account when one is not specified by the send call.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
