# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from ...core.unchecked_base_model import UncheckedBaseModel
from .tenant import Tenant


class TenantListResponse(UncheckedBaseModel):
    cursor: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    A pointer to the next page of results. Defined only when has_more is set to true.
    """

    has_more: bool = pydantic_v1.Field()
    """
    Set to true when there are more pages that can be retrieved.
    """

    items: typing.List[Tenant] = pydantic_v1.Field()
    """
    An array of Tenants
    """

    next_url: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    A url that may be used to generate fetch the next set of results.
    Defined only when has_more is set to true
    """

    url: str = pydantic_v1.Field()
    """
    A url that may be used to generate these results.
    """

    type: typing.Literal["list"] = pydantic_v1.Field()
    """
    Always set to "list". Represents the type of this object.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
